/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

#include "extern.h"

static Shape *desc_shape;

desc_init_init ()
{
	desc_shape = shape_malloc ();
	desc_shape->rank = 1;
	desc_shape->sizes0 = sizes_malloc (1);
	desc_shape->sizes1 = sizes_malloc (1);
	desc_shape->sizes2 = sizes_malloc (1);
	desc_shape->extent = sizes_malloc (1);

	desc_shape->sizes0 [0] = Node_1;
	desc_shape->sizes1 [0] = make_IntegerConstant (32);
	desc_shape->extent [0] = make_IntegerConstant (32);
}

char *desc_name (name)  /* $name_desc */
char *name;
{
	char *str;
	char *tname;
	T_Entry *entry;


	if ((entry = lookup_all (name)) == TN)
		SYSERR;

	tname = entry->orig_name;

	str = (char*) U_malloc (strlen (tname) + 1 + 5 + 1);
/* ##BEGIN##, 03/15/1992, ZEKI */
/* to brint ARRAY_INFO parameter at att_npac_intrinsic function */
/*	sprintf (str, "$%s_desc", tname); */
        sprintf (str, "$%s_info", tname);
/* ##END## */
	return str;
}

char *comm_name (name)  /* $name_desc */
char *name;
{
	char *str;
	char *tname;
	T_Entry *entry;


	if ((entry = lookup_all (name)) == TN)
		SYSERR;

	tname = entry->orig_name;

	str = (char*) U_malloc (strlen (tname) + 1 + 5 + 1);
        sprintf (str, "%s_comm", tname);
	return str;
}


desc_decl ()  /* declares descriptors for arrays that need them */
{
        int first = 1;
        T_Entry *entry;

        for_TABLE_LOOP (entry)
                if (IS_assumed_shape (entry)
                 || IS_assumed_pass (entry))
                        if (first) {
                                first = 0;
                                otab ();
                                oINTEGER ();
                                onam (desc_name (entry->orig_name));
/*                              ostr ("(32)");  ZEKI*/
                                ostr ("(8,7)"); /* This is size of ARRAY_INFO*/
                        }
                        else {
                                ochb (',');
                                onam (desc_name (entry->orig_name));
/*                              ostr ("(32)"); ZEKI*/
                                ostr ("(8,7)");/* This is size of ARRAY_INFO*/

                        }

        if (first == 0)
                odon ();
}


/** BOZKUS **/
comm_decl ()  /* declares comm. descriptors for arrays that need them */
{
	int first = 1;
	T_Entry *entry;

	for_TABLE_LOOP (entry)
		if (IS_comm_element (entry))
			if (first) {
				first = 0;
				otab ();
				oINTEGER ();
				onam (myname_temp(comm_name (entry->orig_name)));
                                ostr ("(5,7)"); /* This is size of ARRAY_COMM*/
			}
			else {
				ochb (',');
				onam (myname_temp(comm_name (entry->orig_name)));
                                ostr ("(5,7)");/* This is size of ARRAY_COMM*/

			}

	if (first == 0)
		odon ();
}

/* ##BEGIN##, 03/15/1992, ZEKI */
/* decleras proclist for attr_npac_intrinsic */
proclist_decl () 
{

 otab ();
 oINTEGER ();
 ostr ("proclist(8)");
 odon ();
}
/* ##END## /*

/* BOZKUS */
/* decleras proclist for attr_npac_intrinsic */
common_decl () 
{

 otab ();
 oINTEGER ();
 ostr("minLoc1, maxLoc1, minLoc2, maxLoc2, coord(3)");
 odon ();

 otab ();
 ostr ("COMMON");
 ostr("/g_to_l/minLoc1, maxLoc1, minLoc2, maxLoc2, coord");
 odon ();


}
/* ##END## */



desc_init_entry (entry)
T_Entry *entry;
{
	int j;
	Shape *shape;
	char *nameout;

	if (IS_assumed_pass (entry)
	&& (!IS_assumed_shape (entry) || IS_result (entry))) {

		ostart ();
		nameout = name_out (desc_name (entry->orig_name));
		otab ();
		ostr (nameout);
		ostr ("(1) = ");
		shape = entry->typ->shape;
		oint ((long) shape->rank);
		odon ();

		for (j = 0; j < shape->rank; j++) {
			otab ();
			ostr (nameout);
			ochb ('(');
			oint ((long) j + 2);
			ostr (") = ");
			write_pass (shape->extent[j]);
			odon ();

			otab ();
			ostr (nameout);
			ochb ('(');
			oint ((long) j + 9);
			ostr (") = ");
			write_pass (shape->sizes0[j]);
			odon ();

			otab ();
			ostr (nameout);
			ochb ('(');
			oint ((long) j + 16);
			ostr (") = ");
			write_pass (shape->sizes1[j]);
			odon ();
		}
		oend ();
	}
}

desc_init ()  /* writes code to initialize the descriptors */
{
	T_Entry *entry;

	for_TABLE_LOOP (entry)
		if (!IS_alloc_temp (entry))
		/*	desc_init_entry (entry);*/
                set_all_intrinsic_info(entry);  /** BOZKUS **/
}

 /** BOZKUS **/
set_all_intrinsic_info(entry)
T_Entry *entry;
{
 	int i;
	Shape *shape;
	char *nameout;
        T_Entry *entry1;
        int template_dim;

	if (IS_assumed_pass (entry)
	&& (!IS_assumed_shape (entry) || IS_result (entry))) {
                if(IS_aligned(entry)) 		
                    shape = entry->local_shape;
                else
                    shape = entry->typ->shape;
                if(shape ==SN) return 0;
		ostart ();
		nameout = name_out (desc_name (entry->orig_name));

               for(i=0; i< shape->rank; i++)
		 {
        	   otab ();
                   oCALL ();
                   ostr ("parameter_for_intrinsic");
                   oLP ();
		   ostr (nameout);
                   oCOMMA();
                   oint((long) i+1);  /* diminsion */
                   oCOMMA();
                   write_pass(shape->sizes0[i]);  /* lb */
                   oCOMMA();
                   write_pass(shape->sizes1[i]);  /* ub */
                   oCOMMA();
                   write_pass(shape->extent[i]);  /* size */
                   oCOMMA();
   /** put distribution style BLOCK or CYCLIC  **/
                if(IS_aligned(entry)) 		
                  {
                  template_dim = shape->distr_dim[i];
                  if(template_dim!=-1)
                   oint((long)entry->align_template->dist_style[template_dim]);
                  else
                    ochb('0');
                  }
                else 
                  ochb('0');

                oCOMMA();
 /** put npoc in that dimension if that dim is not dist nproc=0 **/
                 if(IS_aligned(entry)) 		
		   {
                     if(shape->distr_dim[i]==0)
		       {
                          entry1=lookup_loc(zb_proc_name0);
                          if(IS_parameter(entry1))
                                ostr(entry1->value->com.str);
			   }
                      else if(shape->distr_dim[i]==1)
			   {
                                entry1=lookup_loc(zb_proc_name1);
                                if(IS_parameter(entry1)) 
                                    ostr(entry1->value->com.str);
		           }
                      else  if (shape->distr_dim[i]==-1)
                                ochb('0');
                      else       ochb('0');
		   }
                 else
                   ochb('0');
               
                oRP();
		odon ();
		}
		oend ();
	}
}

Node *desc_extent (name, num)  /* Node for extent of dim num */
char *name;
int num;
{
	Node *node, *sublist, *sub;

	sub = make_Subscript (make_IntegerConstant (num + 2), NN, NN);
	sublist = make_List (&sub, 1, SUBSCRIPT_LIST);
	node = make_ArraySection (make_Name (desc_name (name)) , sublist);

	node->com.typ = typ_malloc ();
	node->com.typ->etype = Etype_INTEGER_0;

	return node;
}

desc_end ()  /* installs descriptors in the symbol table for arrays that need them */
{
	T_Entry *entry, *new_entry;

	for_TABLE_LOOP (entry)
		if (IS_assumed_shape (entry)
		 || IS_assumed_pass (entry)) {
			new_entry = install_loc (desc_name (entry->orig_name), TAB_NAME, 0);
			new_entry->typ = typ_malloc ();
			new_entry->typ->etype = Etype_INTEGER_0;
			SET_temporary (new_entry);
		}
}

desc_put_in_table (entry)
T_Entry *entry;
{
	T_Entry *new_entry;
	char *name = desc_name (entry->orig_name);

	if (lookup_loc (name) != TN)
		return;

	new_entry = install_loc (desc_name (entry->orig_name), TAB_NAME, 0);
	new_entry->typ = typ_malloc ();
	new_entry->typ->etype = Etype_INTEGER_0;
	new_entry->typ->shape = desc_shape;
 /* ##BEGIN##, 02/23/1992, ZEKI */
/* set attr_desc to later elinate it from wrinting intrinsic argument*/
        SET_desc(new_entry);
 /* ##END##  */
	SET_temporary (new_entry);
}
